Attribute VB_Name = "modMain"
Option Explicit

Private Sub Main()
    Dim bc As New CBitCalc
    Dim s As String
    
    s = _
        "Add" & vbNewLine & _
        vbNewLine & _
        "12  +  3  =  " & CStr(bc.Add(12, 3)) & vbNewLine & _
        "-12 + 50  =  " & CStr(bc.Add(-12, 50)) & vbNewLine & _
        "-22  -  40  =  " & CStr(bc.Add(-22, -40))
    Call MsgBox(s)
    
    s = _
        "Multiply" & vbNewLine & _
        vbNewLine & _
        "12  *  100  =  " & CStr(bc.Multiply(12, 100)) & vbNewLine & _
        "-23  *  22  =  " & CStr(bc.Multiply(-23, 22)) & vbNewLine & _
        "-38  *  -44  =  " & CStr(bc.Multiply(-38, -44))
    Call MsgBox(s)
    
    Dim n As Long
    s = _
        "RShift and LShift" & vbNewLine & _
        vbNewLine
    n = bc.LShift(12345, 4)
    s = s & FillUp(DecToBin(12345), 20) & "  <<4  =  " & FillUp(DecToBin(n), 20) & vbNewLine
    n = bc.RShift(12345, 4)
    s = s & FillUp(DecToBin(12345), 20) & "  >>6  =  " & FillUp(DecToBin(n), 20)
    Call MsgBox(s)
    
    Set bc = Nothing
End Sub

'
' Rekursive Prozedur zur Umwandlung einer Dezimalzahl in einen Binrsting ohne fhrende Nullen.
'
Private Function DecToBin(ByVal lngNumber As Long) As String
    If Abs(lngNumber) > 1 Then
        DecToBin = DecToBin(lngNumber \ 2) & CStr(Abs(lngNumber Mod 2))
    Else
        DecToBin = CStr(lngNumber)
    End If
End Function

'
' Fllt einen Binrstring bis zu einer bestimmten Lnge von vorne her mit "0" auf, damit die
' Darstellung schner ist.
'
Private Function FillUp(ByRef strBin As String, ByVal lngLength As Long) As String
    If Len(strBin) < lngLength Then
        FillUp = String$(lngLength - Len(strBin), "0") & strBin
    Else
        FillUp = strBin
    End If
End Function
